KFind Class Reference
Main classes | Find and Replace classes

`#include <kfind.h>`

Inheritance diagram for KFind:

## Public Types

enum | Result { NoMatch, Match }

## Signals

void | highlight (const QString &text, int matchingIndex, int matchedLength)
void | highlight (int id, int matchingIndex, int matchedLength)
void | findNext ()
void | optionsChanged ()
void | dialogClosed ()

## Public Member Functions

| KFind (const QString &pattern, long options, QWidget *parent)
| KFind (const QString &pattern, long options, QWidget *parent, QWidget *findDialog)
virtual | ~KFind ()
bool | needData () const
void | setData (const QString &data, int startPos=-1)
void | setData (int id, const QString &data, int startPos=-1)
Result | find ()
long | options () const
virtual void | setOptions (long options)
QString | pattern () const
void | setPattern (const QString &pattern)
int | numMatches () const
virtual void | resetCounts ()
virtual bool | validateMatch (const QString &text, int index, int matchedlength)
virtual bool | shouldRestart (bool forceAsking=false, bool showNumMatches=true) const
virtual void | displayFinalDialog () const
KDialogBase * | findNextDialog (bool create=false)
void | closeFindNextDialog ()
int | index () const

## Static Public Member Functions

static int | find (const QString &text, const QString &pattern, int index, long options, int *matchedlength)
static int | find (const QString &text, const QRegExp &pattern, int index, long options, int *matchedlength)

## Protected Slots

void | slotFindNext ()
void | slotDialogClosed ()

## Protected Member Functions

QWidget * | parentWidget () const
QWidget * | dialogsParent () const

## Friends

class | KReplace

## Detailed Description

A generic implementation of the "find" function.

Author
  S.R.Haque srhaq.nosp@m.ue@i.nosp@m.ee.or.nosp@m.g, David Faure faure.nosp@m.@kde.nosp@m..org, Arend van Beelen jr. arend.nosp@m.@aut.nosp@m.on.nl

Detail:

This class includes prompt handling etc. Also provides some static functions which can be used to create custom behavior instead of using the class directly.

Example:

To use the class to implement a complete find feature:

In the slot connected to the find action, after using KFindDialog:

// This creates a find-next-prompt dialog if needed.
m_find = new KFind(pattern, options, this);
// Connect highlight signal to code which handles highlighting
// of found text.
connect( m_find, SIGNAL( highlight( const QString &, int, int ) ),
this, SLOT( slotHighlight( const QString &, int, int ) ) );
// Connect findNext signal - called when pressing the button in the dialog
connect( m_find, SIGNAL( findNext() ),
this, SLOT( slotFindNext() ) );

If you are using a non-modal find dialog (the recommended new way in KDE-3.2), you should call right away m_find->closeFindNextDialog().

Then initialize the variables determining the "current position" (to the cursor, if the option FromCursor is set, to the beginning of the selection if the option SelectedText is set, and to the beginning of the document otherwise). Initialize the "end of search" variables as well (end of doc or end of selection). Swap begin and end if FindBackwards. Finally, call slotFindNext();

void slotFindNext()
{
KFind::Result res = KFind::NoMatch;
while ( res == KFind::NoMatch && <position not at end> ) {
if ( m_find->needData() )
m_find->setData( <current text fragment> );
// Let KFind inspect the text fragment, and display a dialog if a match is found
res = m_find->find();
if ( res == KFind::NoMatch ) {
<Move to the next text fragment, honoring the FindBackwards setting for the direction>
}
}
if ( res == KFind::NoMatch ) // i.e. at end
<Call either m_find->displayFinalDialog(); delete m_find; m_find = 0L;
or if ( m_find->shouldRestart() ) { reinit (w/o FromCursor) and call slotFindNext(); }
else { m_find->closeFindNextDialog(); }>
}

Don't forget to delete m_find in the destructor of your class, unless you gave it a parent widget on construction.

This implementation allows to have a "Find Next" action, which resumes the search, even if the user closed the "Find Next" dialog.

A "Find Previous" action can simply switch temporarily the value of FindBackwards and call slotFindNext() - and reset the value afterwards.

Definition at line 103 of file kfind.h.

## Member Enumeration Documentation

enum KFind::Result

Result enum.

Holds information if the find was successful.

Enumerator
NoMatch | No match was found.
Match | A match was found.

Definition at line 139 of file kfind.h.

## Constructor & Destructor Documentation

KFind::KFind | ( | const QString & | pattern,
|  | long | options,
|  | QWidget * | parent
| ) |  |

Only use this constructor if you don't use KFindDialog, or if you use it as a modal dialog.

Parameters

  pattern | The pattern to look for.
  options | Options for the find dialog.

See also
  KFindDialog.

Parameters

  parent | The parent widget.

Definition at line 118 of file kfind.cpp.

KFind::KFind | ( | const QString & | pattern,
|  | long | options,
|  | QWidget * | parent,
|  | QWidget * | findDialog
| ) |  |

This is the recommended constructor if you also use KFindDialog (non-modal).

You should pass the pointer to it here, so that when a message box appears it has the right parent. Don't worry about deletion, KFind will notice if the find dialog is closed.

Parameters

  pattern | The pattern to look for.
  options | Options for the find dialog.

See also
  KFindDialog.

Parameters

  parent | The parent widget.
  findDialog | A pointer to the KFindDialog object.

Definition at line 126 of file kfind.cpp.

KFind::~KFind | ( |  | ) |

virtual

Destructor.

Definition at line 150 of file kfind.cpp.

## Member Function Documentation

void KFind::closeFindNextDialog | ( |  | ) |

Close the "find next?" dialog.

The application should do this when the last match was hit. If the application deletes the KFind, then "find previous" won't be possible anymore.

IMPORTANT: you should also call this if you are using a non-modal find dialog, to tell KFind not to pop up its own dialog.

Definition at line 681 of file kfind.cpp.

void KFind::dialogClosed | ( |  | ) |

signal

Emitted when the 'find next' dialog is being closed.

Some apps might want to remove the highlighted text when this happens. Apps without support for "Find Next" can also do m_find->deleteLater() to terminate the find operation.

void KFind::displayFinalDialog | ( |  | ) | const

virtual

Displays the final dialog saying "no match was found", if that was the case.

Call either this or shouldRestart().

Reimplemented in KReplace.

Definition at line 619 of file kfind.cpp.

KFind::Result KFind::find | ( |  | ) |

Walk the text fragment (e.g.

text-processor line, kspread cell) looking for matches. For each match, emits the highlight() signal and displays the find-again dialog proceeding.

Returns
  Whether or not there has been a match.

Definition at line 221 of file kfind.cpp.

int KFind::find | ( | const QString & | text,
|  | const QString & | pattern,
|  | int | index,
|  | long | options,
|  | int * | matchedlength
| ) |  |

static

Search the given string, and returns whether a match was found.

If one is, the length of the string matched is also returned.

A performance optimised version of the function is provided for use with regular expressions.

Parameters

  text | The string to search.
  pattern | The pattern to look for.
  index | The starting index into the string.
  options | The options to use.
  matchedlength | The length of the string that was matched

Returns
  The index at which a match was found, or -1 if no match was found.

Definition at line 454 of file kfind.cpp.

int KFind::find | ( | const QString & | text,
|  | const QRegExp & | pattern,
|  | int | index,
|  | long | options,
|  | int * | matchedlength
| ) |  |

static

Search the given regular expression, and returns whether a match was found.

If one is, the length of the matched string is also returned.

Another version of the function is provided for use with strings.

Parameters

  text | The string to search.
  pattern | The regular expression pattern to look for.
  index | The starting index into the string.
  options | The options to use.
  matchedlength | The length of the string that was matched

Returns
  The index at which a match was found, or -1 if no match was found.

Definition at line 525 of file kfind.cpp.

KDialogBase * KFind::findNextDialog | ( | bool | create = `false` | ) |

Return (or create) the dialog that shows the "find next?" prompt.

Usually you don't need to call this. One case where it can be useful, is when the user selects the "Find" menu item while a find operation is under way. In that case, the program may want to call setActiveWindow() on that dialog.

Returns
  The find next dialog.

Definition at line 210 of file kfind.cpp.

void KFind::highlight | ( | const QString & | text,
|  | int | matchingIndex,
|  | int | matchedLength
| ) |  |

signal

Connect to this signal to implement highlighting of found text during the find operation.

If you've set data with setData(id, text), use the signal highlight(id, matchingIndex, matchedLength)

Warning
  If you're using the FindIncremental option, the text argument passed by this signal is not necessarily the data last set through setData(), but can also be an earlier set data block.

Parameters

  text | The found text.
  matchingIndex | The index of the found text's occurrence.
  matchedLength | The length of the matched text.

See also
  setData()

void KFind::highlight | ( | int | id,
|  | int | matchingIndex,
|  | int | matchedLength
| ) |  |

signal

Connect to this signal to implement highlighting of found text during the find operation.

Use this signal if you've set your data with setData(id, text), otherwise use the signal with highlight(text, matchingIndex, matchedLength).

Warning
  If you're using the FindIncremental option, the id argument passed by this signal is not necessarily the id of the data last set through setData(), but can also be of an earlier set data block.

Parameters

  id | The ID of the text fragment, as used in setData().
  matchingIndex | The index of the found text's occurrence.
  matchedLength | The length of the matched text.

See also
  setData()

Since
  3.3

int KFind::index | ( |  | ) | const

Returns
  the current matching index ( or -1 ). Same as the matchingIndex parameter passed to highlight. You usually don't need to use this, except maybe when updating the current data, so you need to call setData( newData, index() ).

Since
  3.2

Definition at line 688 of file kfind.cpp.

bool KFind::needData | ( |  | ) | const

Returns
  `true` if the application must supply a new text fragment It also means the last call returned "NoMatch". But by storing this here the application doesn't have to store it in a member variable (between calls to slotFindNext()).

Definition at line 156 of file kfind.cpp.

int KFind::numMatches | ( |  | ) | const

inline

Return the number of matches found (i.e.

the number of times the highlight signal was emitted). If 0, can be used in a dialog box to tell the user "no match was found". The final dialog does so already, unless you used setDisplayFinalDialog(false).

Returns
  The number of matches.

Definition at line 223 of file kfind.h.

long KFind::options | ( |  | ) | const

inline

Return the current options.

Warning: this is usually the same value as the one passed to the constructor, but options might change during the replace operation: e.g. the "All" button resets the PromptOnReplace flag.

Returns
  The current options.

See also
  KFindDialog.

Definition at line 195 of file kfind.h.

void KFind::optionsChanged | ( |  | ) |

signal

Emitted when the options have changed.

This can happen e.g. with "Replace All", or if our 'find next' dialog gets a "find previous" one day.

QString KFind::pattern | ( |  | ) | const

inline

Returns
  the pattern we're currently looking for

Definition at line 208 of file kfind.h.

virtual void KFind::resetCounts | ( |  | ) |

inline virtual

Call this to reset the numMatches count (and the numReplacements count for a KReplace).

Can be useful if reusing the same KReplace for different operations, or when restarting from the beginning of the document.

Reimplemented in KReplace.

Definition at line 231 of file kfind.h.

void KFind::setData | ( | const QString & | data,
|  | int | startPos = `-1`
| ) |  |

Call this when needData returns `true`, before calling find().

Parameters

  data | the text fragment (line)
  startPos | if set, the index at which the search should start. This is only necessary for the very first call to setData usually, for the 'find in selection' feature. A value of -1 (the default value) means "process all the data", i.e. either 0 or data.length()-1 depending on FindBackwards.

Definition at line 169 of file kfind.cpp.

void KFind::setData | ( | int | id,
|  | const QString & | data,
|  | int | startPos = `-1`
| ) |  |

Call this when needData returns `true`, before calling find().

The use of ID's is especially useful if you're using the FindIncremental option.

Parameters

  id | the id of the text fragment
  data | the text fragment (line)
  startPos | if set, the index at which the search should start. This is only necessary for the very first call to setData usually, for the 'find in selection' feature. A value of -1 (the default value) means "process all the data", i.e. either 0 or data.length()-1 depending on FindBackwards.

Since
  3.3

Definition at line 174 of file kfind.cpp.

void KFind::setOptions | ( | long | options | ) |

virtual

Set new options.

Usually this is used for setting or clearing the FindBackwards options.

See also
  KFindDialog.

Definition at line 670 of file kfind.cpp.

void KFind::setPattern | ( | const QString & | pattern | ) |

Change the pattern we're looking for.

Parameters

  pattern | The new pattern.

Definition at line 693 of file kfind.cpp.

bool KFind::shouldRestart | ( | bool | forceAsking = `false`,
|  | bool | showNumMatches = `true`
| ) |  | const

virtual

Returns `true` if we should restart the search from scratch.

Can ask the user, or return `false` (if we already searched the whole document).

Parameters

  forceAsking | set to `true` if the user modified the document during the search. In that case it makes sense to restart the search again.
  showNumMatches | set to `true` if the dialog should show the number of matches. Set to `false` if the application provides a "find previous" action, in which case the match count will be erroneous when hitting the end, and we could even be hitting the beginning of the document (so not all matches have even been seen).

Returns
  `true`, if the search should be restarted.

Reimplemented in KReplace.

Definition at line 629 of file kfind.cpp.

virtual bool KFind::validateMatch | ( | const QString & | text,
|  | int | index,
|  | int | matchedlength
| ) |  |

inline virtual

Virtual method, which allows applications to add extra checks for validating a candidate match.

It's only necessary to reimplement this if the find dialog extension has been used to provide additional criterias.

Parameters

  text | The current text fragment
  index | The starting index where the candidate match was found
  matchedlength | The length of the candidate match

Definition at line 243 of file kfind.h.

The documentation for this class was generated from the following files:

- kfind.h
- kfind.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys